﻿// Copyright (C) 2011 Oliver Sturm <oliver@oliversturm.com>. All rights reserved.

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;
using System.Reflection;

namespace Tracing {
  class Program {
    static void Main(string[] args) {
      Expression<Func<int, int>> squareExp = x => x * x;
      var square = squareExp.Compile( );
      //square = BoringTrace(square);
      Console.WriteLine(square(7));

      Console.WriteLine(SumOfOddNumbers(20));
      //Console.WriteLine(TracedSumOfOddNumbers(20));
    }

    static Func<T, R> BoringTrace<T, R>(Func<T, R> source) {
      return x => {
        Console.WriteLine("--> ({0}) with {1}", source, x);
        var result = source(x);
        Console.WriteLine("<-- Returning ({1}) from ({0})", source, result);
        return result;
      };
    }

    static int SumOfOddNumbers(int cutoff) {
      return Enumerable.Range(1, cutoff).
        Where(x => x % 2 == 1).
        Aggregate(0, (r, v) => r + v);
    }

    //static int TracedSumOfOddNumbers(int cutoff) {
    //  return Enumerable.Range(1, cutoff).
    //    Where(Trace<int, bool>(x => x % 2 == 1)).
    //    Aggregate(0, Trace<int, int, int>((r, v) => r + v));
    //}
  }
}
